Chromium Code Reviews
chromiumcodereview-hr@appspot.gserviceaccount.com (chromiumcodereview-hr) | Please choose your nickname with Settings | Help | Chromium Project | Gerrit Changes | Sign out
(28)

Unified Diff: gdb/contrib/gdb-add-index.sh

Issue 124383005: GDB 7.6.50 (Closed) Base URL: http://git.chromium.org/native_client/nacl-gdb.git@upstream
Patch Set: Created 6 years, 11 months ago
Use n/p to move between diff chunks; N/P to move between comments. Draft comments are only viewable by you.
Jump to:
View side-by-side diff with in-line comments
Download patch
« no previous file with comments | « gdb/contrib/gcc-with-excheck ('k') | gdb/contrib/test_pubnames_and_indexes.py » ('j') | no next file with comments »
Expand Comments ('e') | Collapse Comments ('c') | Show Comments Hide Comments ('s')
Index: gdb/contrib/gdb-add-index.sh
diff --git a/gdb/contrib/gdb-add-index.sh b/gdb/contrib/gdb-add-index.sh
new file mode 100755
index 0000000000000000000000000000000000000000..3ef09defedf671adba964e4151131753276c9613
--- /dev/null
+++ b/gdb/contrib/gdb-add-index.sh
@@ -0,0 +1,69 @@
+#! /bin/sh
+
+# Add a .gdb_index section to a file.
+
+# Copyright (C) 2010, 2012-2013 Free Software Foundation, Inc.
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# This program assumes gdb and objcopy are in $PATH.
+# If not, or you want others, pass the following in the environment
+GDB=${GDB:=gdb}
+OBJCOPY=${OBJCOPY:=objcopy}
+
+myname="${0##*/}"
+
+if test $# != 1; then
+ echo "usage: $myname FILE" 1>&2
+ exit 1
+fi
+
+file="$1"
+
+if test ! -r "$file"; then
+ echo "$myname: unable to access: $file" 1>&2
+ exit 1
+fi
+
+dir="${file%/*}"
+test "$dir" = "$file" && dir="."
+index="${file}.gdb-index"
+
+rm -f $index
+# Ensure intermediate index file is removed when we exit.
+trap "rm -f $index" 0
+
+$GDB --batch -nx -iex 'set auto-load no' \
+ -ex "file $file" -ex "save gdb-index $dir" || {
+ # Just in case.
+ status=$?
+ echo "$myname: gdb error generating index for $file" 1>&2
+ exit $status
+}
+
+# In some situations gdb can exit without creating an index. This is
+# not an error.
+# E.g., if $file is stripped. This behaviour is akin to stripping an
+# already stripped binary, it's a no-op.
+status=0
+
+if test -f "$index"; then
+ $OBJCOPY --add-section .gdb_index="$index" \
+ --set-section-flags .gdb_index=readonly "$file" "$file"
+ status=$?
+else
+ echo "$myname: No index was created for $file" 1>&2
+ echo "$myname: [Was there no debuginfo? Was there already an index?]" 1>&2
+fi
+
+exit $status
« no previous file with comments | « gdb/contrib/gcc-with-excheck ('k') | gdb/contrib/test_pubnames_and_indexes.py » ('j') | no next file with comments »

Powered by Google App Engine
This is Rietveld 408576698